import java.awt.*;
import java.awt.event.*;

public class Class1 extends Frame implements ActionListener, WindowListener
{
	String[] array;		//main array
	boolean init=false;	//draw initial picture or not?
	
	int used=0;			//array positions used
	Label inputLabel1;	//Label
	TextField input1;	//TextField
	TextArea textArea1;	//TextArea
	Button button1;		//Completed clicked
	//end
	
	Button nextButton;	//next button
	int drawType=-1;	//stage of draw
	String currentExample = "main";	//stage of program
	
	MenuBar menuBar;	
	Menu menu;
	MenuItem Example1;
	MenuItem Example2;
	MenuItem Example3;
	
	public static void main(String[] args)
	{
		Class1 f = new Class1();
		f.setSize(500,500);
		f.setVisible(true);
	}

	public Class1()
	{
		
		this.addWindowListener(this);
		setTitle("1D Arrays Examples");
		setLayout(new FlowLayout());
		
		array = new String[20];
		input1 = new TextField();
		button1 = new Button();
		textArea1 = new TextArea(7,30);
		inputLabel1 = new Label();
		nextButton=new Button("Continue");
		
		textArea1.setEditable(false);
		input1.addActionListener(this);
		button1.addActionListener(this);
		nextButton.addActionListener(this);
		
		add(textArea1);
	//	add(nextButton);
		
		textArea1.setFont(new Font("Serif",Font.PLAIN,12));
		textArea1.setText("This section illustrates several examples\n");
		textArea1.append("using 1-dimensional arrays.");
		//end
		
		
		
		
		//menus
		menuBar = new MenuBar();
		menu = new Menu("Begin");
		Example1 = new MenuItem("Example1");
		Example2 = new MenuItem("Example2");
		Example3 = new MenuItem("Example3");
		
		menuBar.add(menu);
		menu.add(Example1);
		menu.add(Example2);
		menu.add(Example3);
		Example1.addActionListener(this);
		Example3.addActionListener(this);
		Example2.addActionListener(this);
		setMenuBar(menuBar);
		
	}

	public void clearScreen()
	{
		remove(input1);
		remove(button1);
		remove(textArea1);
		remove(inputLabel1);
		remove(nextButton);
		doLayout();
		clear();
	}

	public void actionPerformed(ActionEvent e)
	{

		init=true;		//stop drawing initial pic
		if(e.getSource()==nextButton)
		{
				//bring up execution of program
				clearScreen();
				drawType = 0;
				
				inputLabel1.setText("Please enter a sequence of numbers");
				button1 = new Button("Click when done");
				button1.addActionListener(this);
				
				add(inputLabel1);
				add(input1);
				add(button1);			
				doLayout();
				used=0;
				remove(nextButton);
				
				drawDesigns();
		}
		if(e.getSource()==button1)
		{
				clearScreen();
				drawType=2;
				if(currentExample=="Example1")drawEx1();
				if(currentExample=="Example2")drawEx2();
				if(currentExample=="Example3")drawEx3();
		}
		if(e.getSource()==input1)
		{
				array[used]=input1.getText();
				used++;
				input1.setText("");
				drawType=1;
				if(currentExample=="Example1")drawEx1();
				if(currentExample=="Example2")drawEx2();
				if(currentExample=="Example3")drawEx3();
				
		}
		if(e.getSource()==Example1)
		{
			drawType=-1;
			input1.setText("");
			Graphics g= getGraphics();
			clearScreen();
			currentExample="Example1";	
			add(textArea1);
			add(nextButton);
			doLayout();
			
			textArea1.setText("1-Dimensional arrays can be used to\n");
			textArea1.append("store/print multiple pieces of data.\n");
			textArea1.append("This loop is an example of storing and\n");
			textArea1.append("printing data:\n\n");
			
			//One set of example
			g.setColor(Color.black);
			setTitle("Example1");
			
		
			drawDesigns();
			g.setFont(new Font("Serif",Font.ITALIC,12));
			g.drawString("Storing data:",10,220);
			g.setFont(new Font("Serif",Font.PLAIN,12));
			g.drawString("int counter=0;",10,235);
			g.drawString("String[] array = new String[10];",10,250);
			g.drawString("public void actionPerformed(ActionEvent e){",10,265);
			g.drawString("if(e.getSource()==inputTextField){",10,280);
			g.drawString("    array[used] = inputTextField.getText();",10,295);
			g.drawString("    used++;",10,310);
			g.drawString("}...",10,325);
			//end set of example
			
		
			//One set of example
			g.setColor(Color.black);
			g.setFont(new Font("Serif",Font.ITALIC,12));
			g.drawString("Printing data:",250,220);
			g.setFont(new Font("Serif",Font.PLAIN,12));
			g.drawString("public void paint(Graphics g){",250,235);
			g.drawString("    for(int i=0;i<used;i++){",250,250);
			g.drawString("    {",250,265);
			g.drawString("        g.drawString(array[i],100,100+20*i);",250,280);
			g.drawString("    }",250,295);
			g.drawString("}",250,310);
			g.drawString("...",250,325);
			//end set of example
			
	
			g.setFont(new Font("Serif",Font.ITALIC+Font.BOLD,20));
			g.drawString("Example 1",400,70);
			
		
			
		
		}
		if(e.getSource()==Example2)
		{
			drawType=-1;
			input1.setText("");
			Graphics g= getGraphics();
			clearScreen();
			add(textArea1);
			currentExample="Example2";	
			setTitle("Example2");
			textArea1.setText("1-Dimensional arrays can be used to\n");
			textArea1.append("copy multiple pieces of data from one\n");
			textArea1.append("array to another.\n");
			textArea1.append("This loop illustrates how:\n\n");
			
			drawDesigns();
			
			//One set of example
			g.setColor(Color.black);
			g.setFont(new Font("Serif",Font.ITALIC+Font.BOLD,20));
			g.drawString("Example 2",400,70);
			
			g.setFont(new Font("Serif",Font.ITALIC,12));
			g.drawString("Copying data:",10,220);
			g.setFont(new Font("Serif",Font.PLAIN,12));
			g.drawString("public void copy(String[] subject){",10,235);
			g.drawString("    String[] target = new String[subject.length];",10,250);
			g.drawString("    for(int i=0;i<subject.length;i++){",10,265);
			g.drawString("        target[i]=subject[i];",10,280);
			g.drawString("    }",10,295);
			g.drawString("}",10,310);
			//end set of example
			

			add(nextButton);
			doLayout();
			
			
		}
		if(e.getSource()==Example3)
		{
			drawType=-1;
			input1.setText("");
			Graphics g= getGraphics();
			clearScreen();
			add(textArea1);
			currentExample="Example3";	
			setTitle("Example3");
			textArea1.setText("1-Dimensional arrays can be used to\n");
			textArea1.append("reverse the order ofmultiple pieces\n");
			textArea1.append("of data.\n\n");
			textArea1.append("This loop illustrates how:\n\n");
			
			drawDesigns();
			
			//One set of example
			g.setColor(Color.black);
			g.setFont(new Font("Serif",Font.ITALIC+Font.BOLD,20));
			g.drawString("Example 3",400,70);
			
			g.setFont(new Font("Serif",Font.ITALIC,12));
			g.drawString("Switching data:",10,220);
			g.setFont(new Font("Serif",Font.PLAIN,12));
			g.drawString("public void switch(String[] subject){",10,235);
			g.drawString("    String temp;",10,250);
			g.drawString("    for(int i=0;i<subject.length/2;i++){",10,265);
			g.drawString("        temp=subject[i];",10,280);
			g.drawString("        subject[i]=subject[subject.length-i-1];",10,295);
			g.drawString("        subject[subject.length-i-1]=temp;",10,310);
			g.drawString("    }",10,325);
			g.drawString("}",10,340);
			//end set of example
			

			add(nextButton);
			doLayout();
			
			
		}
		
		
	}
	public void drawDesigns()
	{
		Graphics g= getGraphics();
		Color grey= new Color(200,255,200);	//change for each
		Color white = Color.white;
		
		drawCircle(500,500,300,grey);
		drawCircle(500,500,250,white);
		
		drawCircle(500,500,240,grey);
		drawCircle(500,500,230,white);
		
		drawCircle(500,500,90,grey);
		drawCircle(500,500,89,white);
		
		drawCircle(500,500,20,grey);
		
		g.setColor(grey);
		g.fillRect(0,450,500,10);
		g.fillRect(0,470,500,3);
	}
	public void drawCircle(int x, int y, int r, Color color)
	{
		Graphics g= getGraphics();
		g.setColor(color);
		g.fillOval(x-r,y-r,2*r,2*r);
	}
	public void clear()
	{
		Graphics g= this.getGraphics();
		g.setColor(Color.white);
		g.fillRect(0,0,500,500);
	}

	public void backGround()		//draws initial background
	{
		Graphics g= getGraphics();
		g.setFont(new Font("Serif",Font.BOLD,100));

			g.setColor(new Color(200,255,200));		//change 
			g.drawString("A R R A Y",20,280);
			g.setFont(new Font("Serif",Font.BOLD+Font.ITALIC,30));
			g.drawString("EXAMPLES",330,450);
			for(int i=0;i<25;i++)
			{
				g.setColor(new Color(i*10,i*10,i*10));
			
				g.drawOval(100+3*i,100+3*i,500-6*i,500-6*i);
				g.drawOval(130,i*20,20,20);
				g.drawOval(130+2,i*20+2,16,16);
			}
			
			g.setColor(new Color(0,200,0));	//change
			for(int i=0;i<8;i++)
			{
				g.drawRect(50+50*i,300,40,40);
				g.drawRect(51+50*i,301,38,38);
				g.drawRect(52+50*i,302,36,36);
				if(i!=7)
				g.fillRect(90+50*i,319,10,2);
				
				g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
				g.drawString(""+i,50*i+53,325);
			}
	}

	public void slideIn()
	{
		Graphics g= getGraphics();
		for(int i=0;i<30;i++)
		{
			try
			{
				Thread.sleep(50);
				g.drawLine(500-10*i,70,500,70);
			}
			catch(Exception e){}
		}
		g.setFont(new Font("Serif",Font.ITALIC+Font.BOLD,20));
		
		if(currentExample=="Example1")
			g.drawString("Example 1",400,70);
		if(currentExample=="Example2")
			g.drawString("Example 2",400,70);
		if(currentExample=="Example3")
			g.drawString("Example 3",400,70);
		
		
	}
	public void drawEx1()
	{
		Graphics g= getGraphics();
		drawDesigns();
			if(drawType==1 || drawType==2)
			{
				for(int i=0;i<used;i++)
				{
					
					g.setColor(Color.black);
					g.drawRect(50+50*i,300,40,40);
					g.drawRect(51+50*i,301,38,38);
					g.drawRect(52+50*i,302,36,36);
					if(i!=used-1)
						g.fillRect(90+50*i,319,10,2);
							
					g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
					g.drawString(""+array[i],50*i+53,325);
				}
			}
			if(drawType==2)
			{
				int k=70;
				g.setColor(Color.black);
				g.drawString("Original",50,290);
				g.setColor(Color.red);
				g.drawString("Array",50,220);
				
				g.setColor(Color.black);
				for(int i=0;i<used;i++)
				{
					g.setColor(Color.red);
					try
					{
						Thread.sleep(500);
				
						g.drawRect(50+50*i,300-k,40,40);
						g.drawRect(51+50*i,301-k,38,38);
						g.drawRect(52+50*i,302-k,36,36);
						if(i!=used-1)
							g.fillRect(90+50*i,319-k,10,2);
						
						g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
						g.drawString(""+array[i],50*i+53,325-k);									
						
						
				
					}
					catch(Exception e){}
				}
				
				slideIn();
				g.setFont(new Font("Serif",Font.BOLD,14));
				g.setColor(Color.black);
				g.drawString("As each data value is read in it is entered into the array.",50,100);
				g.drawString("The counter increases by one each time, in order to keep",50,120);
				g.drawString("track of the current array index.  This counter may then later be",50,140);
				g.drawString("used to output the data, as seen.",50,160);
			}
	}
	public void drawEx2()
	{
		Graphics g= getGraphics();
		drawDesigns();
		String[] target=new String[array.length];
			if(drawType==1 || drawType==2)
			{
				for(int i=0;i<used;i++)
				{
				g.setColor(Color.black);
				g.drawRect(50+50*i,300,40,40);
				g.drawRect(51+50*i,301,38,38);
				g.drawRect(52+50*i,302,36,36);
				if(i!=used-1)
					g.fillRect(90+50*i,319,10,2);
						
				g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
				g.drawString(""+array[i],50*i+53,325);
				}
			}
			if(drawType==2)
			{
				for(int i=0;i<used;i++)
				{
					target[i]=array[i];
				}
				
				g.drawString("Original:",50,290);
				
				g.setColor(Color.red);
				g.drawString("Subject:",50,220);
				g.setColor(Color.blue);
				g.drawString("Target:",50,360);
				
				g.setColor(Color.black);
				
				
				
				int k=70;	//k = constant to move array pictures by
				for(int i=0;i<used;i++)
				{
					g.setColor(Color.red);
					try
					{
					
			
						Thread.sleep(500);
						g.drawRect(50+50*i,300-k,40,40);
						g.drawRect(51+50*i,301-k,38,38);
						g.drawRect(52+50*i,302-k,36,36);
						if(i!=used-1)
							g.fillRect(90+50*i,319-k,10,2);
						
						g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
						g.drawString(""+array[i],50*i+53,325-k);
						
					}
					catch(Exception e){}
				}
				
				k=-70;
				for(int i=0;i<used;i++)
				{
					g.setColor(Color.blue);
					
					try
					{
						Thread.sleep(500);
						g.drawRect(50+50*i,300-k,40,40);
						g.drawRect(51+50*i,301-k,38,38);
						g.drawRect(52+50*i,302-k,36,36);
						if(i!=used-1)
							g.fillRect(90+50*i,319-k,10,2);
						
						g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
						g.drawString(""+target[i],50*i+53,325-k);
					}
					catch(Exception e){}
				}
				
				slideIn();
				g.setFont(new Font("Serif",Font.BOLD,14));
				g.setColor(Color.black);
				g.drawString("The for-loop goes through each index of the subject array.",50,100);
				g.drawString("As each value is read in, the individual value is copied into",50,120);
				g.drawString("the target array.  Through this method, one may copy one array",50,140);
				g.drawString("to another.",50,160);
			}
	}
	public void drawEx3()
	{
		Graphics g= getGraphics();
		drawDesigns();
		String temp="";
			String[] tempArray=new String[used];
			g.setColor(Color.black);
			int k=0;
			if(drawType==1 || drawType==2)
			{
				for(int i=0;i<used;i++)
				{
					g.drawRect(50+50*i,300-k,40,40);
					g.drawRect(51+50*i,301-k,38,38);
					g.drawRect(52+50*i,302-k,36,36);
					if(i!=used-1)
						g.fillRect(90+50*i,319-k,10,2);
					
					g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
					g.drawString(""+array[i],50*i+53,325-k);
					tempArray[i]=array[i];
				}
			}
			k=70;
			if(drawType==2)
			{
				for(int i=0;i<used/2;i++)
				{
					temp=tempArray[i];
					tempArray[i]=tempArray[used-1-i];
					tempArray[used-i-1]=temp;
				}
				
				g.drawString("Original:",50,300);
				
				g.setColor(Color.red);
				g.drawString("Reversed:",50,230);
				
				g.setColor(Color.black);
			
				
				for(int i=0;i<used;i++)
				{
					g.setColor(Color.red);
					try
					{
						Thread.sleep(500);
						g.drawRect(50+50*i,300-k,40,40);
						g.drawRect(51+50*i,301-k,38,38);
						g.drawRect(52+50*i,302-k,36,36);
						if(i!=used-1)
							g.fillRect(90+50*i,319-k,10,2);
						
						g.setFont(new Font("serif",Font.BOLD+Font.ITALIC,24));
						g.drawString(""+tempArray[i],50*i+53,325-k);
					}
					catch(Exception e){}
				}
				slideIn();
				
				g.setFont(new Font("Serif",Font.BOLD,14));
				g.setColor(Color.black);
				g.drawString("The for-loop used goes through each index of the array",50,100);
				g.drawString("until it reaches the half-way point.  As it reaches each",50,120);
				g.drawString("individual index, the value is switched with the corresponding",50,140);
				g.drawString("index on the other half of the array.  Hence, the loop only",50,160);
				g.drawString("needs to look through the first half of the array.",50,180);
				
				
			}
	}
	public void paint(Graphics g)	//for drawing background
	{
		setBackground(Color.white);
		Font values = new Font("Serif",Font.BOLD,13);
		g.setFont(values);
		g.setColor(Color.gray);

		if(!init)
		{
			backGround();
		}
	}	
	public void windowClosing(WindowEvent e)
	{this.setVisible(false);
	}
	public void windowClosed(WindowEvent e){}
	public void windowOpened(WindowEvent e){}
	public void windowActivated(WindowEvent e){}
	public void windowDeactivated(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
}
